from saref_patterns import SAREF, check_patterns
from rdflib import Graph, Literal, RDF, RDFS, OWL

schema = {
    'description': 'The array of individual state names',
    'type': 'array',
    'items': { 'type': 'string' }
}

def specialize(namespace, execution):
    g = Graph()
    
    super = "".join([state.capitalize() for state in execution]) + "State"
    superLabel = " ".join(execution).capitalize() + " state"
    
    g.add((namespace[super], RDF.type, OWL.Class))
    g.add((namespace[super], RDFS.subClassOf, SAREF.State))
    g.add((namespace[super], RDFS.label, Literal(superLabel, "en")))
    g.add((namespace[super], RDFS.comment, Literal("A type of state", "en")))
    
    for state in execution:
        sub = state.capitalize() + "State"
        subLabel = state.capitalize() + " state"
        g.add((namespace[sub], RDF.type, OWL.Class))
        g.add((namespace[sub], RDFS.subClassOf, namespace[super]))
        g.add((namespace[sub], RDFS.label, Literal(subLabel, "en")))
        g.add((namespace[sub], RDFS.comment, Literal("The state of a device that is " + state.capitalize(), "en")))
        
    return g

if __name__ == "__main__":
    check_patterns(specialize, schema)
