from saref_patterns import SAREF, check_patterns
from rdflib import Graph, Literal, RDF, RDFS, OWL

schema = {
    "type": "object",
    "title": "property class",
    "description": "An object that describes the name and the comment for the property class",
    "properties": {
        "name": { "type": "string" },
        "comment": {"type": "string" }
    },
    "required": ["name", "comment"],
    "additionalProperties": False
};
    
def specialize(namespace, execution):
    name = execution["name"]
    comment = execution["comment"]
    g = Graph()
    g.add((namespace[name], RDF.type, OWL.Class))
    g.add((namespace[name], RDFS.subClassOf, SAREF.Property))
    g.add((namespace[name], RDFS.label, Literal(name, "en")))
    g.add((namespace[name], RDFS.comment, Literal(comment, "en")))
    return g

if __name__ == "__main__":
    check_patterns(specialize, schema)
